## openj9-18 0.33.1

=== omr/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2020 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

# TODO: OMR_RTTI flag
# TODO: Version things

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

message(STATUS "Starting with CMake version ${CMAKE_VERSION}")

include(cmake/versions.cmake) # Required for OMR_VERSION

project(omr VERSION ${OMR_VERSION} LANGUAGES CXX C)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" ${CMAKE_MODULE_PATH})

set_property(GLOBAL PROPERTY USE_FOLDERS TRUE)

include(OmrAssert)
include(OmrFindFiles)
include(OmrHookgen)
include(OmrOption)
include(OmrPlatform)
include(OmrTracegen)
include(OmrTargetSupport)
include(OmrSanitizerSupport)

###
### Set up the global platform configuration
###

if(NOT OMR_PLATFORM_GLOBALLY_INITIALIZED)
	omr_platform_global_setup()
endif()
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

###
### Set up install paths
###
include(GNUInstallDirs)

set(OMR_INSTALL_BIN_DIR ${CMAKE_INSTALL_BINDIR} CACHE PATH "Installation directory for executables")
set(OMR_INSTALL_LIB_DIR ${CMAKE_INSTALL_LIBDIR} CACHE PATH "Installation directory for libraries")
set(OMR_INSTALL_ARCHIVE_DIR ${CMAKE_INSTALL_LIBDIR} CACHE PATH "Installation directory for libraries")
set(OMR_INSTALL_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE PATH "Installation directory for headers")
set(OMR_INSTALL_DATA_DIR ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME} CACHE PATH "Installation directory for data files")

###
### Versions and stuff
###

include(cmake/config.cmake)

enable_testing()

###
### omr_base: basic includes and definitions needed everywhere
###

omr_add_library(omr_base INTERFACE)

target_include_directories(omr_base
	INTERFACE
		$<BUILD_INTERFACE:${omr_SOURCE_DIR}/include_core>
		$<BUILD_INTERFACE:${omr_BINARY_DIR}>
		$<INSTALL_INTERFACE:${OMR_INSTALL_INC_DIR}>
)

if(OMR_OS_ZOS)
	if(OMR_USE_NATIVE_ENCODING)
		target_link_libraries(omr_base INTERFACE omr_ebcdic)
		target_compile_definitions(omr_base
			INTERFACE
				-DOMR_EBCDIC
		)
	else()
		target_link_libraries(omr_base INTERFACE omr_ascii)
	endif()
endif()

if(OMR_WINDOWS_NOMINMAX)
	target_compile_definitions(omr_base INTERFACE -DNOMINMAX)
endif()

install(
	TARGETS omr_base
	EXPORT OmrTargets
)

###
### Source tree checks
###

# Check for existing omrcfg in the source tree since this can cause alot of headaches
# Also check if we are building in tree while we are at it
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if(NOT MSVC_IDE) #MSVC will handle in tree builds ok
		message(WARNING "In tree builds are not recommended")
	endif()
else()
include(cmake/CheckSourceTree.cmake)
add_custom_target(header_check ALL
	${CMAKE_COMMAND} "-Domr_SOURCE_DIR=${omr_SOURCE_DIR}" -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/CheckSourceTree.cmake)
endif()

configure_file(include_core/omrcfg.cmake.h.in omrcfg.h)
configure_file(include_core/omrversionstrings.cmake.h.in omrversionstrings.h)


###
### Set up DDR configuration
###
include(OmrDDRSupport)
if(OMR_DDR)
	make_ddr_set(omrddr)
	ddr_add_headers(omrddr
		${omr_BINARY_DIR}/omrcfg.h
		include_core/j9nongenerated.h
	)
	set_property(TARGET omrddr PROPERTY INCLUDE_DIRECTORIES
		${CMAKE_CURRENT_SOURCE_DIR}/include_core
		${CMAKE_CURRENT_BINARY_DIR}
	)
	set_property(TARGET omrddr PROPERTY DDR_OBJECT_EXCLUDES
		ddr/
		fvtest/
		jitbuilder/
		third_party/
		tools/
	)
endif()

###
### Native Tooling
###

if(OMR_TOOLS_IMPORTFILE)
	include("${OMR_TOOLS_IMPORTFILE}")
elseif(OMR_TOOLS)
	add_subdirectory(tools)
else()
	message(FATAL_ERROR "OMR: Build tools are required. See OMR_TOOLS and OMR_TOOLS_IMPORTFILE")
endif()


###
### Built-in OMR Applications.
###

# Each application provides it's own glue, so must be included before subdirectories.
# The example and om are not yet compatible.
if (OMR_EXAMPLE)
	add_subdirectory(example)
endif (OMR_EXAMPLE)

###
### Core OMR components
###

add_subdirectory(thread)
add_subdirectory(port)
add_subdirectory(util)
add_subdirectory(omr)
add_subdirectory(third_party EXCLUDE_FROM_ALL)
add_subdirectory(omrsigcompat)

if(OMR_RAS_TDF_TRACE)
	add_subdirectory(omrtrace)
endif(OMR_RAS_TDF_TRACE)

if(OMR_GC)
	add_subdirectory(gc)
endif(OMR_GC)

if(OMR_DDR)
	add_subdirectory(ddr)
endif(OMR_DDR)

if(OMR_COMPILER)
	add_subdirectory(compiler)
endif()

if(OMR_JITBUILDER)
	add_subdirectory(jitbuilder)
endif(OMR_JITBUILDER)

if(OMR_SHARED_CACHE)
	add_subdirectory(sharedcache)
endif(OMR_SHARED_CACHE)

# This should come last to ensure dependencies
# are defined
if(OMR_FVTEST)
	add_subdirectory(fvtest)
endif()


# Export CMake Module

# This file must be copied into the build directory so that
# the cmake user package registry functions properly
configure_file(OmrConfig.cmake
  "${CMAKE_CURRENT_BINARY_DIR}/OmrConfig.cmake"
  COPYONLY
)

export(EXPORT OmrTargets FILE OmrTargets.cmake)

install(EXPORT OmrTargets
  FILE OmrTargets.cmake
  DESTINATION ${OMR_INSTALL_LIB_DIR}/cmake/Omr
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/OmrConfig.cmake"
	DESTINATION ${OMR_INSTALL_LIB_DIR}/cmake/Omr
)

export(PACKAGE Omr)

=== openj9/CMakeLists.txt ===
################################################################################
# Copyright (c) 2018, 2020 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
################################################################################

cmake_minimum_required(VERSION 3.4 FATAL_ERROR)

project(openj9)

if("${BOOT_JDK}" STREQUAL "")
	message(FATAL_ERROR "BOOT_JDK must be defined")
endif()

message(STATUS "Using BOOT_JDK: '${BOOT_JDK}'")

# These variables are used by "Java" language support.
find_program(CMAKE_Java_COMPILER NAMES javac PATHS ${BOOT_JDK}/bin NO_DEFAULT_PATH)
find_program(CMAKE_Java_RUNTIME  NAMES java  PATHS ${BOOT_JDK}/bin NO_DEFAULT_PATH)
find_program(CMAKE_Java_AR       NAMES jar   PATHS ${BOOT_JDK}/bin NO_DEFAULT_PATH)

# Variables used by the "UseJava" module (predates "Java" language support)
set(Java_JAVA_EXECUTABLE ${CMAKE_Java_RUNTIME})
set(Java_JAVAC_EXECUTABLE ${CMAKE_Java_COMPILER})
set(Java_JAR_EXECUTABLE ${CMAKE_Java_AR})

add_subdirectory(sourcetools)
add_subdirectory(runtime)

=== omr/compiler/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2018, 2018 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

include(OmrCompilerSupport)

# Add the contents of the macro to CORE_COMPILER_OBJECTS in this scope.
# The library name parameter is currently ignored.
macro(compiler_library libraryname)
	list(APPEND CORE_COMPILER_OBJECTS ${ARGN})
endmacro(compiler_library)

# Instead of a real add_subdirectory we just include the file so everything stays
# in the same scope.
macro(add_compiler_subdirectory dir)
	include("${omr_SOURCE_DIR}/compiler/${dir}/CMakeLists.txt")
endmacro(add_compiler_subdirectory)


# create an object list which is populated in the subdirectories
set(CORE_COMPILER_OBJECTS "")

add_compiler_subdirectory(codegen)
add_compiler_subdirectory(compile)
add_compiler_subdirectory(control)
add_compiler_subdirectory(env)
add_compiler_subdirectory(il)
add_compiler_subdirectory(ilgen)
add_compiler_subdirectory(infra)
add_compiler_subdirectory(optimizer)
add_compiler_subdirectory(ras)
add_compiler_subdirectory(runtime)

add_compiler_subdirectory(${TR_TARGET_ARCH})

# Promote the list variable into a global property.
# That way we dont need to worry about scoping issues.
set_property(GLOBAL PROPERTY OMR_CORE_COMPILER_OBJECTS ${CORE_COMPILER_OBJECTS})

=== omr/ddr/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2020 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at http://eclipse.org/legal/epl-2.0
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

if(NOT OMR_DDR)
	message(FATAL_ERROR ddr disabled)
endif(NOT OMR_DDR)

omr_add_library(omr_ddr_base INTERFACE)

target_link_libraries(omr_ddr_base
	INTERFACE
		omr_base
)

target_include_directories(omr_ddr_base
	INTERFACE
		include/
)

add_subdirectory(lib)
add_subdirectory(tools)
add_subdirectory(test)

=== omr/ddr/Makefile ===
###############################################################################
# Copyright (c) 2015, 2020 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at http://eclipse.org/legal/epl-2.0
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

top_srcdir := ..
include $(top_srcdir)/omrmakefiles/configure.mk

.DEFAULT_GOAL := all

OMR_TOOLCHAIN ?= gcc

ifneq (,$(filter gcc xlc,$(OMR_TOOLCHAIN)))
  DEBUG_FORMAT = dwo
else ifeq (msvc,$(OMR_TOOLCHAIN))
  DEBUG_FORMAT = pdb
else
  $(error DEBUG_FORMAT is undefined)
endif

# Make DEBUG_FORMAT visible to src/cmdline_tool/makefile
export DEBUG_FORMAT

ifeq (win,$(OMR_HOST_OS))
  ifneq (,$(DIASDK_HOME))
    # DIASDK_HOME almost certainly has embedded spaces, so we can't just append
    # to MODULE_INCLUDES; instead, adjust the INCLUDE environment variable.
    export INCLUDE := $(if $(INCLUDE),$(INCLUDE);)$(DIASDK_HOME)/include
  endif
endif

targets = \
  lib \
  test \
  tools

all: $(targets)

$(targets):
	$(MAKE) -C $@ all
.PHONY: $(targets)

tools: lib
test: tools lib

targets_clean := $(addsuffix _clean,$(targets))
clean: $(targets_clean)
$(targets_clean):
	$(MAKE) -C $(patsubst %_clean,%,$@) clean
.PHONY: $(targets_clean)

=== omr/example/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2021 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at http://eclipse.org/legal/epl-2.0
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

include(OmrAssert)
include(OmrTest)

omr_assert(TEST OMR_EXAMPLE)

omr_add_library(omr_example_base INTERFACE)

target_include_directories(omr_example_base
	INTERFACE
		glue
)

target_link_libraries(omr_example_base
	INTERFACE
		omr_base
)

# The GC example shows how to use OMR's GC component
if(OMR_GC)
	omr_add_executable(gcexample
		gcmain.cpp
	)

	target_link_libraries(gcexample
		omr_main_function
		pugixml
		omrcore
		omrvmstartup
		${OMR_GC_LIB}
		${OMR_PORT_LIB}
	)

	omr_add_test(NAME gcexample COMMAND $<TARGET_FILE:gcexample>)
endif(OMR_GC)

add_subdirectory(glue)

=== omr/fvtest/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2021 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at http://eclipse.org/legal/epl-2.0
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

include(OmrAssert)
include(OmrTest)

omr_assert(TEST OMR_FVTEST)

# We currently have a number of sign-comparison warnings that need to be fixed
if(OMR_TOOLCONFIG STREQUAL "gnu")
	omr_append_flags(CMAKE_C_FLAGS "-Wno-error=sign-compare")
	omr_append_flags(CMAKE_CXX_FLAGS "-Wno-error=sign-compare")
endif()

add_subdirectory(util)

add_subdirectory(omrGtestGlue)
add_subdirectory(algotest)
add_subdirectory(coretest)
add_subdirectory(porttest)
add_subdirectory(rastest)
add_subdirectory(sigtest)
add_subdirectory(threadextendedtest)
add_subdirectory(threadtest)
add_subdirectory(utiltest)
add_subdirectory(vmtest)

if(OMR_GC_TEST)
	add_subdirectory(gctest)
endif()

if(OMR_GC_API_TEST)
	add_subdirectory(gc_api_test)
endif()

if(OMR_JITBUILDER_TEST)
	add_subdirectory(jitbuildertest)
endif()

if(OMR_TEST_COMPILER)
	add_subdirectory(compilertest)
endif()

if(OMR_LLJB_TEST)
	add_subdirectory(lljbtest)
endif()

if(OMR_JITBUILDER_TEST)
	add_subdirectory(tril)
	add_subdirectory(compilertriltest)
	add_subdirectory(compilerunittest)
endif()

=== omr/gc/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2022 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

omr_assert(TEST OMR_GC)

omr_assert(
	TEST OMR_GC_GLUE_TARGET
	MESSAGE "OMR_GC_GLUE_TARGET must be set."
)

omr_add_hookgen(
	INPUT include/omrmm.hdf
	PUBLIC_DIR "${omr_BINARY_DIR}"
	TARGETS omrgc_hookgen
)

omr_add_hookgen(
	INPUT base/omrmmprivate.hdf
	TARGETS omrgc_hookgen
)

add_custom_target(omrgc_hookgen
	DEPENDS
		"${omr_BINARY_DIR}/mmomrhook.h"
		"${CMAKE_CURRENT_BINARY_DIR}/mmprivatehook.h"
)

add_tracegen(base/j9mm.tdf)
add_tracegen(base/omrmm.tdf)
add_tracegen(verbose/j9vgc.tdf)

# Ideally We would handle the tracegen stuff like the hookgen stuff above
# But for whatever reason that breaks the ninja builds
omr_add_library(omrgc_tracegen OBJECT
	${CMAKE_CURRENT_BINARY_DIR}/ut_j9mm.c
	${CMAKE_CURRENT_BINARY_DIR}/ut_omrmm.c
	${CMAKE_CURRENT_BINARY_DIR}/ut_j9vgc.c
)

target_include_directories(omrgc_tracegen
	PUBLIC
		$<TARGET_PROPERTY:omr_base,INTERFACE_INCLUDE_DIRECTORIES>
)

target_compile_definitions(omrgc_tracegen
	PUBLIC
		$<TARGET_PROPERTY:omr_base,INTERFACE_COMPILE_DEFINITIONS>
)

target_compile_options(omrgc_tracegen
	PUBLIC
		$<TARGET_PROPERTY:omr_base,INTERFACE_COMPILE_OPTIONS>
)

set(omrgc_sources
	base/AddressOrderedListPopulator.cpp
	base/AllocationContext.cpp
	base/AllocationInterfaceGeneric.cpp
	base/BaseVirtual.cpp
	base/BumpAllocatedListPopulator.cpp
	base/CardTable.cpp
	base/Collector.cpp
	base/Configuration.cpp
	base/EmptyListPopulator.cpp
	base/EnvironmentBase.cpp
	base/Forge.cpp
	base/GCCode.cpp
	base/GCExtensionsBase.cpp
	base/GlobalAllocationManager.cpp
	base/GlobalCollector.cpp
	base/Heap.cpp
	base/HeapMap.cpp
	base/HeapMapIterator.cpp
	base/HeapMemorySubSpaceIterator.cpp
	base/HeapRegionDescriptor.cpp
	base/HeapRegionIterator.cpp
	base/HeapRegionManager.cpp
	base/HeapRegionManagerTarok.cpp
	base/HeapVirtualMemory.cpp
	base/LightweightNonReentrantLock.cpp
	base/LightweightNonReentrantRWLock.cpp
	base/MarkedObjectPopulator.cpp
	base/MarkingScheme.cpp
	base/MarkMap.cpp
	base/MarkMapSegmentChunkIterator.cpp
	base/MainGCThread.cpp
	base/Math.cpp
	base/MemoryManager.cpp
	base/MemoryPool.cpp
	base/MemoryPoolAddressOrderedList.cpp
	base/MemoryPoolAddressOrderedListBase.cpp
	base/MemoryPoolBumpPointer.cpp
	base/MemoryPoolHybrid.cpp
	base/MemoryPoolLargeObjects.cpp
	base/MemoryPoolSplitAddressOrderedList.cpp
	base/MemoryPoolSplitAddressOrderedListBase.cpp
	base/MemorySpace.cpp
	base/MemorySubSpace.cpp
	base/MemorySubSpaceChildIterator.cpp
	base/MemorySubSpaceFlat.cpp
	base/MemorySubSpaceGeneric.cpp
	base/MemorySubSpacePoolIterator.cpp
	base/MemorySubSpaceRegionIterator.cpp
	base/MemorySubSpaceUniSpace.cpp
	base/ModronAssertions.cpp
	base/NUMAManager.cpp
	base/NonVirtualMemory.cpp
	base/OMRVMInterface.cpp
	base/OMRVMThreadInterface.cpp
	base/ObjectAllocationInterface.cpp
	base/ObjectHeapBufferedIterator.cpp
	base/ObjectHeapIteratorAddressOrderedList.cpp
	base/Packet.cpp
	base/PacketList.cpp
	base/ParallelDispatcher.cpp
	base/ParallelHeapWalker.cpp
	base/ParallelObjectHeapIterator.cpp
	base/ParallelMarkTask.cpp
	base/ParallelTask.cpp
	base/PhysicalArena.cpp
	base/PhysicalArenaRegionBased.cpp
	base/PhysicalArenaVirtualMemory.cpp
	base/PhysicalSubArena.cpp
	base/PhysicalSubArenaRegionBased.cpp
	base/PhysicalSubArenaVirtualMemory.cpp
	base/PhysicalSubArenaVirtualMemoryFlat.cpp
	base/ReferenceChainWalkerMarkMap.cpp
	base/RegionPool.cpp
	base/RegionPoolGeneric.cpp
	base/SparseAddressOrderedFixedSizeDataPool.cpp
	base/SparseVirtualMemory.cpp
	base/StartupManager.cpp
	base/SweepHeapSectioning.cpp
	base/SweepPoolManager.cpp
	base/SweepPoolManagerAddressOrderedList.cpp
	base/SweepPoolManagerAddressOrderedListBase.cpp
	base/SweepPoolManagerHybrid.cpp
	base/SweepPoolManagerSplitAddressOrderedList.cpp
	base/SweepPoolState.cpp
	base/TLHAllocationInterface.cpp
	base/TLHAllocationSupport.cpp
	base/Task.cpp
	base/VirtualMemory.cpp
	base/WorkPacketOverflow.cpp
	base/WorkPackets.cpp
	base/WorkStack.cpp
	base/gcspinlock.cpp
	base/gcutils.cpp
	base/modronapicore.cpp

	startup/mminitcore.cpp
	startup/omrgcalloc.cpp
	startup/omrgcstartup.cpp

	stats/AllocationStats.cpp
	stats/CardCleaningStats.cpp
	stats/ClassUnloadStats.cpp

	stats/FreeEntrySizeClassStats.cpp
	stats/HeapResizeStats.cpp
	stats/LargeObjectAllocateStats.cpp
	stats/MarkStats.cpp
	stats/MetronomeStats.cpp
	stats/RootScannerStats.cpp
	stats/ScavengerStats.cpp # TODO only compile if scavenger or VLHGC. Is this actually used by VLHGC?
	stats/SweepStats.cpp

	structs/ForwardedHeader.cpp
	structs/HashTableIterator.cpp
	structs/OMRVMThreadListIterator.cpp
	structs/PoolIterator.cpp
	structs/SublistFragment.cpp
	structs/SublistIterator.cpp
	structs/SublistPool.cpp
	structs/SublistPuddle.cpp
	structs/SublistSlotIterator.cpp

	# verbose/j9vgc.tdf
	verbose/VerboseBuffer.cpp
	verbose/VerboseHandlerOutput.cpp
	verbose/VerboseManager.cpp
	verbose/VerboseWriter.cpp
	verbose/VerboseWriterChain.cpp
	verbose/VerboseWriterFileLogging.cpp
	verbose/VerboseWriterFileLoggingBuffered.cpp
	verbose/VerboseWriterFileLoggingSynchronous.cpp
	verbose/VerboseWriterHook.cpp
	verbose/VerboseWriterStreamOutput.cpp
	verbose/handler_standard/VerboseHandlerOutputStandard.cpp
	$<TARGET_OBJECTS:omrgc_tracegen>
)

omr_add_library(omrgc STATIC
	${omrgc_sources}
)

target_enable_ddr(omrgc EARLY_SOURCE_EVAL)
ddr_set_add_targets(omrddr omrgc)
ddr_add_headers(omrgc
	base/HeapMap.hpp
	include/omrmodroncore.h
	structs/ForwardedHeader.hpp
)

if(OMR_GC_OBJECT_MAP)
	set(objmap_sources
		base/ObjectMap.cpp
	)

	target_sources(omrgc
		PRIVATE
			${objmap_sources}
	)
endif()

if(OMR_GC_MODRON_STANDARD)
	set(modronstandard_sources
		base/standard/ConfigurationFlat.cpp
		base/standard/ConfigurationStandard.cpp
		base/standard/CopyScanCacheChunk.cpp
		base/standard/CopyScanCacheChunkInHeap.cpp
		base/standard/EnvironmentStandard.cpp
		base/standard/HeapMemoryPoolIterator.cpp
		base/standard/HeapRegionDescriptorStandard.cpp
		base/standard/HeapRegionManagerStandard.cpp
		base/standard/HeapWalker.cpp
		base/standard/OverflowStandard.cpp
		base/standard/ParallelGlobalGC.cpp
		base/standard/ParallelSweepScheme.cpp
		base/standard/SweepHeapSectioningSegmented.cpp
		base/standard/WorkPacketsStandard.cpp
	)

	target_sources(omrgc
		PRIVATE
			${modronstandard_sources}
	)

	if(OMR_GC_MODRON_COMPACTION)
		set(modroncompaction_sources
				base/standard/CompactFixHeapForWalkTask.cpp
				base/standard/CompactScheme.cpp
				base/standard/ParallelCompactTask.cpp

				stats/CompactStats.cpp
		)

		target_sources(omrgc
			PRIVATE
				${modroncompaction_sources}
		)
	endif()

	if(OMR_GC_MODRON_CONCURRENT_MARK)
		set(modronconcurrentmark_sources
				base/standard/ConcurrentCardTable.cpp
				base/standard/ConcurrentCardTableForWC.cpp
				base/standard/ConcurrentClearNewMarkBitsTask.cpp
				base/standard/ConcurrentCompleteTracingTask.cpp
				base/standard/ConcurrentFinalCleanCardsTask.cpp
				base/standard/ConcurrentGC.cpp
				base/standard/ConcurrentGCIncrementalUpdate.cpp
				base/standard/ConcurrentGCSATB.cpp
				base/standard/ConcurrentOverflow.cpp
				base/standard/ConcurrentPrepareCardTableTask.cpp
				base/standard/ConcurrentSafepointCallback.cpp
				base/standard/RememberedSetSATB.cpp
				base/standard/WorkPacketsConcurrent.cpp
				base/standard/WorkPacketsSATB.cpp

				stats/ConcurrentGCStats.cpp
		)

		target_sources(omrgc
			PRIVATE
				${modronconcurrentmark_sources}
		)

		if(OMR_GC_MODRON_SCAVENGER)
			set(mcm_modronscavenger_sources
				base/standard/ConcurrentScanRememberedSetTask.cpp
			)

			target_sources(omrgc
				PRIVATE
					${mcm_modronscavenger_sources}
			)
		endif()
	endif()

	if(OMR_GC_CONCURRENT_SWEEP)
		set(concurrentsweep_sources
			base/standard/ConcurrentSweepScheme.cpp
		)

		target_sources(omrgc
			PRIVATE
				${concurrentsweep_sources}
		)
	endif()

	if(OMR_GC_MODRON_SCAVENGER)
		set(modronscavenger_sources
				base/HeapSplit.cpp # TODO delete as this should not be used anymore!
				base/MemorySubSpaceGenerational.cpp
				base/MemorySubSpaceSemiSpace.cpp

				base/standard/ConfigurationGenerational.cpp
				base/standard/CopyScanCacheList.cpp
				base/standard/ParallelScavengeTask.cpp
				base/standard/PhysicalSubArenaVirtualMemorySemiSpace.cpp
				base/standard/RSOverflow.cpp
				base/standard/Scavenger.cpp

				stats/ScavengerCopyScanRatio.cpp
		)

		target_sources(omrgc
			PRIVATE
				${modronscavenger_sources}
		)

		if(OMR_GC_CONCURRENT_SCAVENGER)
			set(ms_concurrentscavenger_sources
				base/standard/ConcurrentScavengeTask.cpp
			)

			target_sources(omrgc
				PRIVATE
					${ms_concurrentscavenger_sources}
			)
		endif()
	endif()
endif()

if(OMR_GC_SEGREGATED_HEAP)
	set(segregatedheap_sources
		base/segregated/AllocationContextSegregated.cpp
		base/segregated/ConfigurationSegregated.cpp
		base/segregated/GlobalAllocationManagerSegregated.cpp
		base/segregated/HeapRegionDescriptorSegregated.cpp
		base/segregated/LockingFreeHeapRegionList.cpp
		base/segregated/LockingHeapRegionQueue.cpp
		base/segregated/MemoryPoolAggregatedCellList.cpp
		base/segregated/MemoryPoolSegregated.cpp
		base/segregated/MemorySubSpaceSegregated.cpp
		base/segregated/ObjectHeapIteratorSegregated.cpp
		base/segregated/OverflowSegregated.cpp
		base/segregated/RegionPoolSegregated.cpp
		base/segregated/SegregatedAllocationInterface.cpp
		base/segregated/SegregatedAllocationTracker.cpp
		base/segregated/SegregatedGC.cpp
		base/segregated/SegregatedListPopulator.cpp
		base/segregated/SegregatedMarkingScheme.cpp
		base/segregated/SegregatedSweepTask.cpp
		base/segregated/SizeClasses.cpp
		base/segregated/SweepSchemeSegregated.cpp
		base/segregated/WorkPacketsSegregated.cpp
	)

	target_sources(omrgc
		PRIVATE
			${segregatedheap_sources}
	)
	ddr_add_headers(omrgc base/segregated/RegionPoolSegregated.hpp)
endif()

if(OMR_GC_VLHGC)
	set(vlhgc_sources
		base/vlhgc/HeapRegionStateTable.cpp
	)

	target_sources(omrgc
		PRIVATE
			${vlhgc_sources}
	)

	set(vlhgc_include
		base/vlhgc
	)

	target_include_directories(omrgc
		PUBLIC
			${vlhgc_include}
	)
endif()

add_dependencies(omrgc omrgc_hookgen)

set(gc_include_public
	.
	${CMAKE_CURRENT_BINARY_DIR}  #Ideally this should be private, but the glue pulls this in
	base
	base/segregated
	base/standard
	include
	startup
	stats
	structs
	verbose
	verbose/handler_standard
)

target_include_directories(omrgc
	PUBLIC
		${gc_include_public}
	INTERFACE
		$<TARGET_PROPERTY:${OMR_GC_GLUE_TARGET},INTERFACE_INCLUDE_DIRECTORIES>
)

set(gc_link_libraries_public
	omr_base
)
set(gc_link_libraries_private
	omrutil
	omrcore
	${OMR_THREAD_LIB}
	${OMR_PORT_LIB}
	${OMR_HOOK_LIB}
)

target_link_libraries(omrgc
	PUBLIC
		${gc_link_libraries_public}
	PRIVATE
		${OMR_GC_GLUE_TARGET}
		${gc_link_libraries_private}
)
set_target_properties(omrgc omrgc_hookgen omrgc_tracegen PROPERTIES FOLDER gc)

if(OMR_MIXED_REFERENCES_MODE_STATIC)

=== omr/jitbuilder/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2021 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

include(OmrCompilerSupport)

find_package(PythonInterp REQUIRED)

# JitBuilder Files
set(JITBUILDER_OBJECTS
	env/FrontEnd.cpp
	compile/ResolvedMethod.cpp
	control/Jit.cpp
	ilgen/JBIlGeneratorMethodDetails.cpp
	optimizer/JBOptimizer.hpp
	optimizer/JBOptimizer.cpp
	optimizer/Optimizer.hpp
	runtime/JBCodeCacheManager.cpp
	runtime/JBJitConfig.cpp
)

if(OMR_ARCH_X86)
	list(APPEND JITBUILDER_OBJECTS
		x/codegen/Evaluator.cpp
	)
elseif(OMR_ARCH_S390)
	list(APPEND JITBUILDER_OBJECTS
		z/codegen/Evaluator.cpp
	)
elseif(OMR_ARCH_POWER)
	list(APPEND JITBUILDER_OBJECTS
		p/codegen/Evaluator.cpp
		p/runtime/CodeSync.cpp
		p/runtime/AsmUtil.spp
		p/runtime/CodeDispatch.spp
		${omr_SOURCE_DIR}/compiler/p/env/OMRDebugEnv.cpp
	)
endif()

# Generated client API files
set(CPP_API_GENERATOR ${CMAKE_CURRENT_SOURCE_DIR}/apigen/cppgen.py)
set(JITBUILDER_CPP_API_HEADER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/release/cpp/include)
set(JITBUILDER_CPP_API_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}client/cpp)
set(JITBUILDER_API_DESCRIPTION ${CMAKE_CURRENT_SOURCE_DIR}/apigen/jitbuilder.api.json)

set(JITBUILDER_API_SOURCES
	${JITBUILDER_CPP_API_SOURCE_DIR}/BytecodeBuilder.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/IlBuilder.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/IlType.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/IlValue.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/MethodBuilder.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/ThunkBuilder.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/TypeDictionary.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/VirtualMachineOperandArray.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/VirtualMachineOperandStack.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/VirtualMachineRegister.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/VirtualMachineRegisterInStruct.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/VirtualMachineState.cpp
	${JITBUILDER_CPP_API_SOURCE_DIR}/JitBuilder.cpp
)

set(JITBUILDER_API_HEADERS
	${JITBUILDER_CPP_API_HEADER_DIR}/BytecodeBuilder.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/IlBuilder.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/IlType.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/IlValue.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/MethodBuilder.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/ThunkBuilder.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/TypeDictionary.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/VirtualMachineOperandArray.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/VirtualMachineOperandStack.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/VirtualMachineRegister.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/VirtualMachineRegisterInStruct.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/VirtualMachineState.hpp
	${JITBUILDER_CPP_API_HEADER_DIR}/JitBuilder.hpp
)

add_custom_command(
	OUTPUT ${JITBUILDER_API_SOURCES} ${JITBUILDER_API_HEADERS}
	COMMAND ${CMAKE_COMMAND} -E make_directory ${JITBUILDER_CPP_API_SOURCE_DIR}
	COMMAND ${CMAKE_COMMAND} -E make_directory ${JITBUILDER_CPP_API_HEADER_DIR}
	COMMAND ${PYTHON_EXECUTABLE} ${CPP_API_GENERATOR} ${JITBUILDER_API_DESCRIPTION} --sourcedir ${JITBUILDER_CPP_API_SOURCE_DIR} --headerdir ${JITBUILDER_CPP_API_HEADER_DIR}
	DEPENDS ${CPP_API_GENERATOR} ${JITBUILDER_API_DESCRIPTION}
	COMMENT "Running JitBuilder C++ API generator"
)

list(APPEND JITBUILDER_OBJECTS
	${JITBUILDER_API_SOURCES}
)

if(OMR_ARCH_X86 OR OMR_ARCH_S390)
	set(OMR_ENHANCED_WARNINGS OFF)
else()
	set(OMR_WARNINGS_AS_ERRORS OFF)
	set(OMR_ENHANCED_WARNINGS OFF)
endif()

# Create jitbuilder library.
create_omr_compiler_library(
	NAME    jitbuilder
	OBJECTS ${JITBUILDER_OBJECTS}
	DEFINES PROD_WITH_ASSUMES JITTEST
)

# Add interface path so that include paths propagate.
# NOTE: `release` directory isn't being automatically setup, so this
#       is adding the actual compiler dir, as opposed to the 'composed'
#       install directory.
target_include_directories(jitbuilder
	INTERFACE
		${JITBUILDER_CPP_API_HEADER_DIR}
)

target_link_libraries(jitbuilder
	PUBLIC
		${OMR_PORT_LIB}
)

# JitBuilder examples only work on 64 bit currently.
if(OMR_JITBUILDER AND OMR_ENV_DATA64)
	add_subdirectory(release)
endif()

if(OMR_JITBUILDER_TEST)
	add_test(
		NAME TestJitBuilderAPIGenerator
		COMMAND ${PYTHON_EXECUTABLE} run_tests.py
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/apigen
	)
endif()

if(OMR_LLJB)
	add_subdirectory(lljb)
endif()

# install(TARGETS jitbuilder
#         ARCHIVE       DESTINATION ${CMAKE_BINARY_DIR}/jitbuilder_release
#         PUBLIC_HEADER DESTINATION ${CMAKE_BINARY_DIR}/jitbuilder_release/include
#         )
#
# # Create release directory
# file(MAKE_DIRECTORY jitbuilder_release)
# file(COPY ${jitbuilder_library} DESTINATION jitbuilder_release)
# file(COPY ${CMAKE_SOURCE_DIR}/compiler/env   DESTINATION jitbuilder_release/include)
# file(COPY ${CMAKE_SOURCE_DIR}/compiler/il    DESTINATION jitbuilder_release/include)
# file(COPY ${CMAKE_SOURCE_DIR}/compiler/ilgen DESTINATION jitbuilder_release/include)

=== omr/jitbuilder/Makefile ===
###############################################################################
# Copyright (c) 2016, 2018 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

#
# "all" should be the first target to appear so it's the default
#
.phony: all clean cleandeps cleandll
all:
clean:
cleandeps:
cleandll:

# This is the logic right now for locating Clang and LLVM-config
# There's probably a nicer way to do all of this... it's pretty bad

ifeq ($(PLATFORM),amd64-linux64-clang)
    # Luckily we can just use the default path for Clang :)
else ifeq ($(PLATFORM),ppc64-linux64-clang)
    export CC_PATH?=/tr/llvm_checker/ppc-64/sles11/bin/clang
    export CXX_PATH?=/tr/llvm_checker/ppc-64/sles11/bin/clang++
else ifeq ($(PLATFORM),s390-zos64-vacpp)
    export CC_PATH?=/usr/lpp/cbclib/xlc/bin/xlc
    export CXX_PATH?=/usr/lpp/cbclib/xlc/bin/xlC
    export A2E_INCLUDE_PATH?=/usr/lpp/cbclib/include
else
    # we can use default path for gcc
    # ($(PLATFORM),aarch64-linux-gcc)
    # ($(PLATFORM),arm-linux-gcc)
    export CC_PATH?=$(shell which $(CC))
    export CXX_PATH?=$(shell which $(CXX))
    export AS_PATH?=$(shell which $(AS))
endif


ASSUMES=1

#
# First setup some important paths
# Personally, I feel it's best to default to out-of-tree build but who knows, there may be
# differing opinions on that.
#
JIT_SRCBASE?=..
JIT_OBJBASE?=../build
JIT_DLL_DIR?=../jitbuilder/release

#
# Now we need to cleanup these variables on Windows
#
FIXED_SRCBASE=$(subst \,/,$(JIT_SRCBASE))
FIXED_OBJBASE=$(subst \,/,$(JIT_OBJBASE))
FIXED_DLL_DIR=$(subst \,/,$(JIT_DLL_DIR))

# TODO - "debug" as default?
BUILD_CONFIG?=prod

#
# This is where we setup our component dirs
# Note these are all relative to JIT_SRCBASE and JIT_OBJBASE
# It just makes sense since source and build dirs may be in different places 
# in the filesystem :)
#
JIT_OMR_DIRTY_DIR?=compiler
JIT_PRODUCT_DIR?=jitbuilder

#
# Dirs used internally by the makefiles
#
JIT_MAKE_DIR?=$(JIT_SRCBASE)/$(JIT_PRODUCT_DIR)/build
JIT_SCRIPT_DIR?=$(JIT_SRCBASE)/tools/compiler/scripts

#
# First we set a bunch of tokens about the platform that the rest of the
# makefile will use as conditionals
#
include $(JIT_MAKE_DIR)/platform/common.mk

#
# Now we include the names of all the files that will go into building the JIT
# Will automatically include files needed from HOST and TARGET platform
#
include $(JIT_MAKE_DIR)/files/common.mk

#
# Now we configure all the tooling we will use to build the files
#
# There is quite a bit of shared stuff, but the overwhelming majority of this
# is toolchain-dependent.
#
# That makes sense - You can't expect XLC and GCC to take the same arguments
#
include $(JIT_MAKE_DIR)/toolcfg/common.mk

#
# Here's where everything has been setup and we lay down the actual targets and
# recipes that Make will use to build them
#
include $(JIT_MAKE_DIR)/rules/common.mk

=== omr/omr/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2020 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

omr_add_tracegen(omrti.tdf)
omr_add_tracegen(omrvm.tdf)

add_subdirectory(startup)

omr_assert(
	TEST OMR_CORE_GLUE_TARGET
	MESSAGE "OMR_CORE_GLUE_TARGET must be set. Try using the example with OMR_EXAMPLE=ON"
)

omr_assert(
	TEST OMR_RAS_GLUE_TARGET
	MESSAGE "OMR_RAS_GLUE_TARGET must be set. Try using the example with OMR_EXAMPLE=ON"
)

omr_add_library(omrcore STATIC
	OMR_Agent.cpp
	OMR_MethodDictionary.cpp
	OMR_Profiler.cpp
	OMR_Runtime.cpp
	OMR_TI.cpp
	OMR_TIMemorySize.cpp
	OMR_VM.cpp
	OMR_VMThread.cpp
	${CMAKE_CURRENT_BINARY_DIR}/ut_omrti.c
	${CMAKE_CURRENT_BINARY_DIR}/ut_omrvm.c
)

target_include_directories(omrcore
	PUBLIC
		.
	PRIVATE
		${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(omrcore
	PUBLIC
		omr_base
	PRIVATE
		${OMR_CORE_GLUE_TARGET}
		${OMR_RAS_GLUE_TARGET}
)

if(OMR_GC)
	add_dependencies(omrcore
		omrgc_tracegen
		omrgc_hookgen
	)

	target_include_directories(omrcore
		PRIVATE
			$<TARGET_PROPERTY:${OMR_GC_LIB},INTERFACE_INCLUDE_DIRECTORIES>
			$<TARGET_PROPERTY:${OMR_GC_GLUE_TARGET},INTERFACE_INCLUDE_DIRECTORIES>
	)
endif(OMR_GC)

target_enable_ddr(omrcore)
ddr_set_add_targets(omrddr omrcore)

=== omr/omrsigcompat/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2017, 2021 IBM Corp. and others
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] http://openjdk.java.net/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
###############################################################################

include(OmrMsvcRuntime)

omr_add_library(omrsig SHARED
	omrsig.cpp
)

if(OMR_OS_WINDOWS)
	target_compile_definitions(omrsig PRIVATE -DMSVC_RUNTIME_DLL="${OMR_MSVC_CRT}")
endif()

omr_add_exports(omrsig
	omrsig_primary_signal
	omrsig_handler
	signal
)
if(NOT OMR_OS_WINDOWS)
	omr_add_exports(omrsig
		omrsig_primary_sigaction
		sigaction
		sigset
		sigignore
		bsd_signal
		sysv_signal
	)
endif()
if(OMR_OS_LINUX OR OMR_OS_OSX)
	omr_add_exports(omrsig
		__sysv_signal
		ssignal
	)
endif()
if(OMR_OS_ZOS)
	omr_add_exports(omrsig
		__sigactionset
	)
endif()
if((NOT OMR_OS_WINDOWS) AND (NOT OMR_OS_ZOS))
	omr_add_exports(omrsig
		sigvec
	)
endif()

target_link_libraries(omrsig
	PRIVATE
		omr_base
		omrutil
)

target_compile_options(omrsig
	PRIVATE
		${OMR_PLATFORM_SHARED_COMPILE_OPTIONS}
)

if(OMR_HOST_OS MATCHES "linux|osx")
	target_link_libraries(omrsig PRIVATE dl)
endif()

install(
	TARGETS omrsig
	EXPORT OmrTargets
	PUBLIC_HEADER DESTINATION ${OMR_INSTALL_INC_DIR}/
	ARCHIVE DESTINATION ${OMR_INSTALL_ARCHIVE_DIR}/
	LIBRARY DESTINATION ${OMR_INSTALL_LIB_DIR}/
)

target_enable_ddr(omrsig)
ddr_set_add_targets(omrddr omrsig)

=== debian/changelog ===
openj9-18 (0.33.1-1) unstable; urgency=medium

  * Rebuild with new package names

 -- Mathieu Baudier <mbaudier@argeo.org>  Wed, 05 Nov 2025 16:58:08 +0000

=== debian/control ===
Source: openj9-18
Section: java
Priority: optional
Maintainer: Mathieu Baudier <mbaudier@argeo.org>
Build-Depends: openjdk-17-jdk,
 lsb-release, debhelper-compat (= 13), build-essential,
 g++, gcc,
 ca-certificates, cmake, cpio, curl, file, git,
 libasound2-dev, libcups2-dev, libdwarf-dev, libelf-dev, libexpat1-dev, libffi-dev, libfontconfig, libfontconfig1-dev, libfreetype6-dev, libnuma-dev,
 libssl-dev, libx11-dev, libxext-dev, libxrandr-dev, libxrender-dev, libxt-dev, libxtst-dev, make, nasm, pkg-config, systemtap-sdt-dev,
 unzip, wget, xvfb, zip, zlib1g-dev,
 libgif-dev, libjpeg-dev, libpng-dev, liblcms2-dev, libharfbuzz-dev, libxinerama-dev, libkrb5-dev, libpcsclite-dev, libxrandr-dev,
# nvidia-cuda-dev, nvidia-cuda-toolkit
Standards-Version: 4.5.1
Homepage: https://www.eclipse.org/openj9/
Vcs-Git: https://code.argeo.org/restricted/deb/openj9.git
Rules-Requires-Root: binary-targets

Package: openj9-18-jdk
Architecture: any
Priority: optional
Depends: java-common,
         ${misc:Depends},
         ${shlibs:Depends},
Description: OpenJ9 JVM with OpenJDK
 OpenJ9 is an alternative Java Virtual Machine (instead of HotSpot).

Package: openj9-18-jmods
Architecture: any
Priority: optional
Description: OpenJ9 JVM with OpenJDK (jmods)

Package: openj9-18-source
Architecture: any
Priority: optional
Description: OpenJ9 JVM with OpenJDK (source)

Package: openj9-18-sdk
Architecture: any
Priority: optional
Depends: openj9-18-jdk (= ${binary:Version}),
         openj9-18-source (= ${binary:Version}),
         openj9-18-jmods (= ${binary:Version})
Description: Meta-package with the dependencies for a fully functional Java development environment based on OpenJ9

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

version_date = $(shell date --iso-8601)

# Linux-style architecture
LINUX_HOST_ARCH=$(shell uname -m)

# Derivative
distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

BOOT_JDK=/usr/lib/jvm/java-17-openjdk-$(DEB_HOST_ARCH)

ifeq ($(distrel),bullseye)
WITH_OPENSSL=fetched
else
WITH_OPENSSL=system
endif

# Same naming as in openjdk official Debian build
origin		= openj9
shortver	= 18
jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
d_jvmlib	= /usr/lib/jvm
basedir	= $(d_jvmlib)/$(jdirname)

basename	= $(origin)-$(shortver)
p_jrehl	= $(basename)
d_jrehl	= debian/$(p_jrehl)

absarchdir = $(CURDIR)/$(d_jrehl)/$(basedir)/lib
shlibdeps_ld_path =$(absarchdir):$(absarchdir)/j9vm:$(absarchdir)/compressedrefs

dpkg_buildflags_hs = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_STRIP="-Wno-error" \
	DEB_CXXFLAGS_MAINT_STRIP="-Wno-error" \
	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
dpkg_buildflags_hs += \
	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
dpkg_buildflags_hs += dpkg-buildflags
export EXTRA_CPPFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CFLAGS_HS   := $(shell $(dpkg_buildflags_hs) --get CFLAGS; $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CXXFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CXXFLAGS) -Wno-deprecated-declarations
export EXTRA_LDFLAGS_HS  := $(shell $(dpkg_buildflags_hs) --get LDFLAGS)

ifeq ($(DEB_HOST_ARCH),arm64)
ifeq ($(distribution),ubuntu)
# Optimize for Raspberry Pi 5
EXTRA_CPPFLAGS_ARGEO += -march=armv8.2-a+crypto+fp16+rcpc+dotprod
endif
endif

ifeq ($(DEB_HOST_ARCH),amd64)
# Optimize for AVX-512
#EXTRA_CPPFLAGS_ARGEO += -march=skylake-avx512
endif

ENABLE_JITSERVER=--enable-jitserver

# Extra Argeo flags
# -fpermissive: avoid issues with newer compilers
# -DNDEBUG: disable assertions
EXTRA_CPPFLAGS_ARGEO=-O3 -DNDEBUG
EXTRA_CXXFLAGS_ARGEO=-fpermissive

%:
	dh $@

override_dh_auto_clean:
	if [ -d "./build" ]; then make dist-clean; rm -rf ./build; fi
	rm -f *.log

override_dh_auto_configure:
	bash ./configure \
	$(ENABLE_JITSERVER) \
	--with-extra-cflags='$(EXTRA_CPPFLAGS_HS) $(EXTRA_CFLAGS_HS) $(EXTRA_CPPFLAGS_ARGEO) $(EXTRA_CFLAGS_ARGEO)' \
	--with-extra-cxxflags='$(EXTRA_CPPFLAGS_HS) $(EXTRA_CXXFLAGS_HS) $(EXTRA_CPPFLAGS_ARGEO) $(EXTRA_CXXFLAGS_ARGEO)' \
	--with-extra-ldflags='$(EXTRA_LDFLAGS_HS) $(EXTRA_LDFLAGS_ARGEO) $(LDFLAGS)' \
	--with-jni-libpath=/usr/lib/$(DEB_HOST_MULTIARCH)/jni:/usr/lib/jni:/lib/jni:$(basedir)/lib:/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib:/lib/$(DEB_HOST_MULTIARCH):/lib \
	--disable-warnings-as-errors \
	--disable-warnings-as-errors-omr \
	--disable-warnings-as-errors-openj9 \
	--with-debug-level=release \
	--with-stdc++lib=dynamic \
	--with-openssl=$(WITH_OPENSSL) \
	--with-libjpeg=system \
	--with-giflib=system \
	--with-libpng=system \
	--with-zlib=system \
	--with-lcms=system \
	--with-harfbuzz=system \
	--with-freetype=system \
	--with-version-pre=argeo \
	--with-version-opt= \
	--with-version-date=$(version_date) \
	--with-boot-jdk=$(BOOT_JDK)/

#	--enable-cuda --with-cuda=/usr \

override_dh_auto_build:
	make jdk-image

override_dh_auto_test:
	echo Skip tests

override_dh_auto_install:
	mkdir -p $(CURDIR)/$(d_jrehl)-jdk/usr/lib/jvm
	
	# copy the whole built JDK and then dispatch files to the subpackages 
	cp -rp ./build/linux-$(LINUX_HOST_ARCH)-server-release/images/jdk $(CURDIR)/$(d_jrehl)-jdk/$(basedir)
	
	# jmods
	mkdir -p $(CURDIR)/$(d_jrehl)-jmods/$(basedir)
	mv $(CURDIR)/$(d_jrehl)-jdk/$(basedir)/jmods $(CURDIR)/$(d_jrehl)-jmods/$(basedir)
	
	# source
	mkdir -p $(CURDIR)/$(d_jrehl)-source/$(basedir)/lib
	mv $(CURDIR)/$(d_jrehl)-jdk/$(basedir)/lib/src.zip $(CURDIR)/$(d_jrehl)-source/$(basedir)/lib
	
override_dh_shlibdeps:
	dh_shlibdeps -a -L $(p_jrehl) -l$(shlibdeps_ld_path) --

override_dh_dwz:
	echo Disable dh_dwz since it is failing
